unit UFFTExemplo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Math,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Spin, MPlayer, WaveHandle,
  FFT;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Panel2: TPanel;
    PaintBox2: TPaintBox;
    FFT1: TFFT;
    FFT2: TFFT;
    Panel3: TPanel;
    PaintBox3: TPaintBox;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    BitBtn2: TBitBtn;
    ProgressBar1: TProgressBar;
    CheckBoxNoise: TCheckBox;
    WaveHandle1: TWaveHandle;
    BitBtn3: TBitBtn;
    CheckBoxFilter: TCheckBox;
    TrackBarFilter: TTrackBar;
    LabelPeak: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure TrackBarFilterChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Linha, Linha1 : array[0..512] of double;
    Espectro : array[1..256] of double;

    WaveRIFFHeader: TWaveRIFFHeader;
    WaveFormatChunk: TWaveFormatChunk;
    WaveDataChunk: TWaveDataChunk;
    Buffer: TArrayWave;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
var i : word;
    n : double;
    NewRect : TRect;
    Noise: double;
begin
   { Sintetizao do sinal a partir de funes seno }
   Randomize;
   Noise := 1;
   for i := 1 to 256 do
   begin
      Linha[i] := TrackBar1.Position / 20 * sin(-2 * PI * i / 256) +
                  TrackBar2.Position / 20 * sin(-2 * PI * 2 * i / 256) +
                  TrackBar3.Position / 20 * sin(-2 * PI * 3 * i / 256) +
                  TrackBar4.Position / 20 * sin(-2 * PI * 4 * i / 256) +
                  TrackBar5.Position / 20 * sin(-2 * PI * 5 * i / 256) +
                  TrackBar6.Position / 20 * sin(-2 * PI * 6 * i / 256) +
                  TrackBar7.Position / 20 * sin(-2 * PI * 7 * i / 256) +
                  TrackBar8.Position / 20 * sin(-2 * PI * 8 * i / 256);

      { Presena de rudo no sinal }            
      if CheckBoxNoise.Checked then Noise := 1 - Random(300)/1000;

      { Ajusta o sinal para o vetor da entrada da transformada }
      Linha[i] := Noise * Linha[i];
      Linha1[2*i-1] := Linha[i];
      Linha1[2*i] := 0;
   end;

   { Limpa o primeiro paintbox }
   NewRect := Rect(0, 0, PaintBox1.Width, PaintBox1.Height);
   PaintBox1.Canvas.Brush.Color := clBlack;
   PaintBox1.Canvas.FillRect(NewRect);

   { Traa a onda }
   for i := 1 to 256 do
      PaintBox1.Canvas.Pixels[i-1, (PaintBox1.Height - 128) - Trunc(Linha[i]/2 * PaintBox1.Height) div SpinEdit1.Value] := clWhite;

   { Executa a FFT direta }
   FFT1.DoFFT(Linha1);

   { Limpa o segundo paintbox }
   NewRect := Rect(0, 0, PaintBox2.Width, PaintBox2.Height);
   PaintBox2.Canvas.Brush.Color := clBlack;
   PaintBox2.Canvas.FillRect(NewRect);

   { Calcula o espectro }
   i := 1;
   while (i <= 256) do
   begin
      Espectro[i] := Sqrt(Linha1[2*i-1]*Linha1[2*i-1] + Linha1[2*i]*Linha1[2*i]);
      Inc(i);
   end;

   { Traa o espectro }
   PaintBox2.Canvas.Pen.Color := clWhite;
   i := 1;
   while i <= 256 do
   begin
      PaintBox2.Canvas.MoveTo(i-1, PaintBox2.Height div 2);
      PaintBox2.Canvas.LineTo(i-1, PaintBox2.Height - Trunc(Espectro[i] * PaintBox2.Height/256 + 128));
      Inc(i);
   end;

   { Processo de filtragem (corte de alta frequncia) }
   if CheckBoxFilter.Checked then
   begin
      i := 1;
      while (i <= 256) do
      begin
         if (i >= TrackBarFilter.Position) and (i <= (256-TrackBarFilter.Position)) then
         begin
            { Zera as componentes superiores  frequncia de corte }
            Linha1[2*i-1] := 0;
            Linha1[2*i] := 0;
         end;
         Inc(i);
      end;

      { Mostra linha de corte }
      PaintBox2.Canvas.Pen.Color := clRed;
      PaintBox2.Canvas.MoveTo(TrackBarFilter.Position-1, 0);
      PaintBox2.Canvas.LineTo(TrackBarFilter.Position-1, PaintBox2.Height div 2);
      PaintBox2.Canvas.MoveTo(256-TrackBarFilter.Position, 0);
      PaintBox2.Canvas.LineTo(256-TrackBarFilter.Position, PaintBox2.Height div 2);
      PaintBox2.Canvas.Pen.Color := clWhite;
   end;

   { Limpa terceiro paintbox }
   NewRect := Rect(0, 0, PaintBox3.Width, PaintBox3.Height);
   PaintBox3.Canvas.Brush.Color := clBlack;
   PaintBox3.Canvas.FillRect(NewRect);

   { Executa FFT inversa }
   FFT2.DoFFT(Linha1);

   { Traa onda recomposta no paintbox }
   for i := 1 to 256 do
      PaintBox3.Canvas.Pixels[i-1, (PaintBox3.Height - 128) - Trunc((Linha1[2*i-1])/512 * PaintBox3.Height) div SpinEdit1.Value] := clWhite;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
   { Atualiza paintbox }
   BitBtn1Click(Sender);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var F, i, j: integer;
   Fator1, Fator2, freq : double;
   Peak, Value: integer;
begin
   { Para fins didticos, a gravao do arquivo passo-a-passo sem usar o mtodo Save }
   { Cria o arquivo }
   F := FileCreate('Sample1.WAV');

   { Grava o cabealho }
   with WaveRIFFHeader do
   begin
      ID := 'RIFF';
      Len := 25636;
      IDWave := 'WAVE';
   end;
   FileWrite(F, WaveRIFFHeader, SizeOf(WaveRIFFHeader));

   { Grava o chunk de formato }
   with WaveFormatChunk do
   begin
      ID := 'fmt ';
      Len := 16;
      FormatTag := 1;
      Channels := 1;
      SamplesPerSec := 44100;
      AvgBytesPerSec := 88200;
      BlockAlign := 2;
      BitsPerSample := 16;
   end;
   FileWrite(F, WaveFormatChunk, SizeOf(WaveFormatChunk));

   { Grava o chunk de dados }
   with WaveDataChunk do
   begin
      ID := 'data';
      Len := 25600;
   end;
   FileWrite(F, WaveDataChunk, SizeOf(WaveDataChunk));

   { Grava os dados propriamente ditos }
   Peak := 0;
   ProgressBar1.Position := 0;
   for j := 0 to 99 do
   begin
      i := 0;
      while i < 256 do
      begin
         { Normaliza o valor da amostra do vetor Linha }
         Value := Round(Linha1[2*i-1] / 256 * 32768 / SpinEdit1.Value);
         { A faixa de valores possveis situa-se entre [-32768,32767] }
         Buffer[j*256+i] := Max(-32768,Min(32767,Value));
         { Obtm o valor mximo da onda (sem o corte) }
         if Value > Peak then Peak := Value;
         Inc(i);
      end;
      ProgressBar1.Position := j;
   end;
   FileWrite(F, Buffer, SizeOf(Buffer));

   { Fecha o arquivo }
   FileClose(F);

   { Limpa o componente }
   WaveHandle1.Clear;

   { Carrega de novo }
   WaveHandle1.Load;

   { Calcula pico mximo em dB (valor de corte: 0 dB = 32767) }
   if Peak > 0 then
      LabelPeak.Caption := Format('%3.2f dB',[20*Ln(Peak/32767)/Ln(10)])
   else
      LabelPeak.Caption := '-Inf';

end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
   { Associa o nome do arquivo }
   WaveHandle1.WAVFile := 'Sample1.WAV';
   { Reproduz o som gravado }
   WaveHandle1.Play;
end;

procedure TForm1.TrackBarFilterChange(Sender: TObject);
begin
   { Atualiza paintbox }
   BitBtn1.Click;
end;

end.
