unit UGeraDTMF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Math,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Spin, MPlayer, WaveHandle;

type
  TFGeraDTMF = class(TForm)
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Panel2: TPanel;
    PaintBox2: TPaintBox;
    Panel3: TPanel;
    PaintBox3: TPaintBox;
    BitBtn2: TBitBtn;
    ProgressBar1: TProgressBar;
    WaveHandle1: TWaveHandle;
    BitBtn3: TBitBtn;
    LabelPeak: TLabel;
    RgTeclas: TRadioGroup;
    RgGraphic: TRadioGroup;
    LbLow: TLabel;
    LbHigh: TLabel;
    SaveDialog: TSaveDialog;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure RgTeclasClick(Sender: TObject);
    procedure RgGraphicClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Sinal, SinalL, SinalH : array[0..21799] of double;

    WaveRIFFHeader: TWaveRIFFHeader;
    WaveFormatChunk: TWaveFormatChunk;
    WaveDataChunk: TWaveDataChunk;
    Buffer: TArrayWave;
  end;

var
  FGeraDTMF: TFGeraDTMF;

implementation

{$R *.DFM}

procedure TFGeraDTMF.RgTeclasClick(Sender: TObject);
var i: integer;
   L, H: double;
begin
   with RgTeclas do
   begin
      if Items.Strings[ItemIndex] = '0' then
      begin
         L := 23.43; H := 16.50;
      end;
      if Items.Strings[ItemIndex] = '1' then
      begin
         L := 31.64; H := 18.24;
      end;
      if Items.Strings[ItemIndex] = '2' then
      begin
         L := 31.64; H := 16.50;
      end;
      if Items.Strings[ItemIndex] = '3' then
      begin
         L := 31.64; H := 14.93;
      end;
      if Items.Strings[ItemIndex] = '4' then
      begin
         L := 28.64; H := 18.24;
      end;
      if Items.Strings[ItemIndex] = '5' then
      begin
         L := 28.64; H := 16.50;
      end;
      if Items.Strings[ItemIndex] = '6' then
      begin
         L := 28.64; H := 14.93;
      end;
      if Items.Strings[ItemIndex] = '7' then
      begin
         L := 25.88; H := 18.24;
      end;
      if Items.Strings[ItemIndex] = '8' then
      begin
         L := 25.88; H := 16.50;
      end;
      if Items.Strings[ItemIndex] = '9' then
      begin
         L := 25.88; H := 14.93;
      end;
      if Items.Strings[ItemIndex] = 'A' then
      begin
         L := 31.64; H := 13.50;
      end;
      if Items.Strings[ItemIndex] = 'B' then
      begin
         L := 28.64; H := 13.50;
      end;
      if Items.Strings[ItemIndex] = 'C' then
      begin
         L := 25.88; H := 13.50;
      end;
      if Items.Strings[ItemIndex] = 'D' then
      begin
         L := 23.43; H := 13.50;
      end;
      if Items.Strings[ItemIndex] = '*' then
      begin
         L := 23.43; H := 18.24;
      end;
      if Items.Strings[ItemIndex] = '#' then
      begin
         L := 23.43; H := 14.93;
      end;
      for i := 0 to 21799 do
      begin
         { Compe os vetores }
         SinalL[i] := sin(2 * PI * i / L);
         SinalH[i] := sin(2 * PI * i / H);
         { Calcula as frequncias }
         LbLow.Caption := IntToStr(Round(22050 / L)) + ' Hz';
         LbHigh.Caption := IntToStr(Round(22050 / H)) + ' Hz';
         { A intensidade da frequncia mais baixa deve ser um pouco maior que a alta }
         Sinal[i] := (0.6*SinalL[i] + 0.4*SinalH[i]);
      end;
   end;

   { Traa a onda }
   RgGraphicClick(Self);
end;

procedure TFGeraDTMF.BitBtn2Click(Sender: TObject);
var F, i, j: integer;
   Fator1, Fator2, freq : double;
   Peak, Value: integer;
   FName: string;
begin
   if RgTeclas.Items.Strings[RgTeclas.ItemIndex] <> '*' then
      FName := RgTeclas.Items.Strings[RgTeclas.ItemIndex] +'.WAV'
   else
      FName := 'Star.WAV';

   { Associa nome do arquivo }   
   SaveDialog.FileName := FName;

   if SaveDialog.Execute then
   begin
      { Para fins didticos, a gravao do arquivo passo-a-passo sem usar o mtodo Save }
      { Cria o arquivo }
      F := FileCreate(FName);

      { Grava o cabealho }
      with WaveRIFFHeader do
      begin
         ID := 'RIFF';
         Len := 21836;
         IDWave := 'WAVE';
      end;
      FileWrite(F, WaveRIFFHeader, SizeOf(WaveRIFFHeader));

      { Grava o chunk de formato }
      with WaveFormatChunk do
      begin
         ID := 'fmt ';
         Len := 16;
         FormatTag := 1;
         Channels := 1;
         SamplesPerSec := 22050;
         AvgBytesPerSec := 44100;
         BlockAlign := 2;
         BitsPerSample := 16;
      end;
      FileWrite(F, WaveFormatChunk, SizeOf(WaveFormatChunk));

      { Grava o chunk de dados }
      with WaveDataChunk do
      begin
         ID := 'data';
         Len := 21800;
      end;
      FileWrite(F, WaveDataChunk, SizeOf(WaveDataChunk));

      { Grava os dados propriamente ditos }
      Peak := 0;
      ProgressBar1.Position := 0;
      for i := 0 to 21799 do
      begin
         { Normaliza o valor da amostra do vetor Linha }
         Value := Round(Sinal[i] * 32768);
         { A faixa de valores possveis situa-se entre [-32768,32767] }
         Buffer[i] := Max(-32768,Min(32767,Value));
         { Obtm o valor mximo da onda (sem o corte) }
         if Value > Peak then Peak := Value;
         ProgressBar1.Position := i;
      end;
      FileWrite(F, Buffer, SizeOf(Buffer));

      { Fecha o arquivo }
      FileClose(F);

      { Limpa o componente }
      WaveHandle1.Clear;

      { Carrega de novo }
      WaveHandle1.Load;

      { Calcula pico mximo em dB (valor de corte: 0 dB = 32767) }
      if Peak > 0 then
         LabelPeak.Caption := Format('%3.2f dB',[20*Ln(Peak/32767)/Ln(10)])
      else
         LabelPeak.Caption := '-Inf';
   end; {SaveDialog}

   { Refaz paintbox }
   RgGraphicClick(Self);
end;

procedure TFGeraDTMF.BitBtn3Click(Sender: TObject);
begin
   { Associa o nome do arquivo }
   with RgTeclas do
      if Items.Strings[ItemIndex] <> '*' then
         WaveHandle1.WAVFile := Items.Strings[ItemIndex]+'.WAV'
      else
         WaveHandle1.WAVFile := 'Star.WAV';
   { Reproduz o som gravado }
   WaveHandle1.Play;
end;

procedure TFGeraDTMF.RgGraphicClick(Sender: TObject);
var NewRect: TRect;
    i: integer;
begin
   { Limpa paintbox }
   NewRect := Rect(0, 0, PaintBox1.Width, PaintBox1.Height);
   PaintBox1.Canvas.Brush.Color := clBlack;
   PaintBox1.Canvas.FillRect(NewRect);

   { Limpa paintbox }
   NewRect := Rect(0, 0, PaintBox2.Width, PaintBox2.Height);
   PaintBox2.Canvas.Brush.Color := clBlack;
   PaintBox2.Canvas.FillRect(NewRect);

   { Limpa paintbox }
   NewRect := Rect(0, 0, PaintBox3.Width, PaintBox3.Height);
   PaintBox3.Canvas.Brush.Color := clBlack;
   PaintBox3.Canvas.FillRect(NewRect);

   if RgGraphic.ItemIndex = 1 then
   begin
      for i := 0 to 255 do
         PaintBox1.Canvas.Pixels[i, (PaintBox1.Height - PaintBox1.Height div 2) - Trunc(SinalL[i]/2 * PaintBox1.Height)] := clLime;

      for i := 0 to 255 do
         PaintBox2.Canvas.Pixels[i, (PaintBox2.Height - PaintBox2.Height div 2) - Trunc(SinalH[i]/2 * PaintBox2.Height)] := clLime;

      for i := 0 to 511 do
         PaintBox3.Canvas.Pixels[i, (PaintBox3.Height - PaintBox3.Height div 2) - Trunc(Sinal[i]/2 * PaintBox3.Height)] := clLime;
   end
   else
   begin
      PaintBox1.Canvas.Pen.Color := clLime;
      PaintBox2.Canvas.Pen.Color := clLime;
      PaintBox3.Canvas.Pen.Color := clLime;
      for i := 0 to 255 do
      begin
         PaintBox1.Canvas.MoveTo(i, PaintBox1.Height div 2);
         PaintBox1.Canvas.LineTo(i, (PaintBox1.Height div 2) - Trunc(SinalL[i]/2 * PaintBox1.Height));
      end;

      PaintBox2.Canvas.Pen.Color := clLime;
      for i := 0 to 255 do
      begin
         PaintBox2.Canvas.MoveTo(i, PaintBox2.Height div 2);
         PaintBox2.Canvas.LineTo(i, (PaintBox2.Height div 2) - Trunc(SinalH[i]/2 * PaintBox2.Height));
      end;

      PaintBox3.Canvas.Pen.Color := clLime;
      for i := 0 to 511 do
      begin
         PaintBox3.Canvas.MoveTo(i, PaintBox3.Height div 2);
         PaintBox3.Canvas.LineTo(i, (PaintBox3.Height div 2) - Trunc(Sinal[i]/2 * PaintBox3.Height));
      end;
   end;
end;

procedure TFGeraDTMF.PaintBox1Paint(Sender: TObject);
begin
   { Refaz paintbox }
   RgGraphicClick(Self);
end;

end.
