unit UMontSeq;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, WaveHandle, Mask, ExtCtrls, ComCtrls;

type
  TFMontSeq = class(TForm)
    Panel2: TPanel;
    Panel3: TPanel;
    Bt7: TSpeedButton;
    Bt8: TSpeedButton;
    Bt9: TSpeedButton;
    Bt4: TSpeedButton;
    Bt5: TSpeedButton;
    Bt6: TSpeedButton;
    Bt1: TSpeedButton;
    Bt2: TSpeedButton;
    Bt3: TSpeedButton;
    Bt0: TSpeedButton;
    MeSequence: TMaskEdit;
    WaveHandle: TWaveHandle;
    BtnGenerate: TBitBtn;
    BtnPlay: TBitBtn;
    BtClear: TSpeedButton;
    SaveDialog: TSaveDialog;
    StatusBar: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure Bt0Click(Sender: TObject);
    procedure BtClearClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtnGenerateClick(Sender: TObject);
    procedure BtnPlayClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    DataStream: array[0..9,0..43599] of SmallInt;
    DataResult: array[0..511999] of SmallInt;
    Path: string;
  end;

var
  FMontSeq: TFMontSeq;

implementation

{$R *.dfm}

procedure TFMontSeq.FormCreate(Sender: TObject);
begin
   MeSequence.Clear;

   { Faz a leitura dos dados }
   { L primeiro o dgito zero e carrega formatos }
   Path := 'C:\Livro\Exemplos\10\Teste\';
   WaveHandle.Clear;
   WaveHandle.WAVFile := Path + '0.WAV';
   WaveHandle.Load;

   { Coloca os dgitos na stream de dados }
   WaveHandle.LoadData(Path + '0.WAV', DataStream[0]);
   WaveHandle.LoadData(Path + '1.WAV', DataStream[1]);
   WaveHandle.LoadData(Path + '2.WAV', DataStream[2]);
   WaveHandle.LoadData(Path + '3.WAV', DataStream[3]);
   WaveHandle.LoadData(Path + '4.WAV', DataStream[4]);
   WaveHandle.LoadData(Path + '5.WAV', DataStream[5]);
   WaveHandle.LoadData(Path + '6.WAV', DataStream[6]);
   WaveHandle.LoadData(Path + '7.WAV', DataStream[7]);
   WaveHandle.LoadData(Path + '8.WAV', DataStream[8]);
   WaveHandle.LoadData(Path + '9.WAV', DataStream[9]);
end;

procedure TFMontSeq.Bt0Click(Sender: TObject);
begin
   if Length(MeSequence.Text) < 10 then
   begin
      MeSequence.Text := MeSequence.Text + IntToStr((Sender as TSpeedButton).Tag);
   end;
end;

procedure TFMontSeq.BtClearClick(Sender: TObject);
begin
   MeSequence.Clear;
   BtnPlay.Enabled := False;
   StatusBar.Panels[0].Text := '';
end;

procedure TFMontSeq.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action := caFree;
   FMontSeq := nil;
end;

procedure TFMontSeq.BtnGenerateClick(Sender: TObject);
var i, j, k, Digit: integer;
    Len: integer;
begin
   if MeSequence.Text <> '' then
   begin
      { Sugesto do nome do arquivo }
      SaveDialog.FileName := MeSequence.Text;
      if SaveDialog.Execute then
      begin
         { L primeiro o dgito zero e carrega formatos }
         WaveHandle.Clear;
         WaveHandle.WAVFile := Path + '0.WAV';
         WaveHandle.Load;

         J := 0;
         for K := 1 to Length(MeSequence.Text) do
         begin
            { Pega dgito }
            Digit := StrToInt(Copy(MeSequence.Text,K,1));

            { Transfere os dados (apenas 1/4 do perodo) }
            for I := 0 to (WaveHandle.LengthData div 4)-1 do
            begin
               DataResult[J] := DataStream[Digit,I];
               Inc(J);
            end;
            { Incluir pausa }
            for I := 0 to 1499 do
            begin
               DataResult[J] := 0;
               Inc(J);
            end;

         end;
         { Aps processar os dgitos e montar a sequncia, grava o arquivo }
         WaveHandle.WaveRIFFHeader.Len := J*2 + SizeOf(TWaveRIFFHeader) + SizeOf(TWaveFormatChunk);
         WaveHandle.WaveDataChunk.Len := J*2;
         WaveHandle.SaveData(SaveDialog.FileName, J*2, DataResult);

         { Retorna valores anteriores dos cabealhos }
         WaveHandle.WaveRIFFHeader.Len := WaveHandle.Length;
         WaveHandle.WaveDataChunk.Len := WaveHandle.LengthData;
         StatusBar.Panels[0].Text := 'Amostra gerada';
         BtnPlay.Enabled := True;
      end;
   end;
end;

procedure TFMontSeq.BtnPlayClick(Sender: TObject);
begin
   WaveHandle.WAVFile := SaveDialog.FileName;
   WaveHandle.Load;
   WaveHandle.Play;
end;

end.
