unit UTreinSOMMLP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Grids, Db, DBTables, DBGrids, DBCtrls, WaveHandle, FFT,
  StdCtrls, Buttons, ComCtrls, Som, MLP;

const
   DATASIZE = 1024;

type
  TFTreinSOMMLP = class(TForm)
    FFT: TFFT;
    WaveHandle: TWaveHandle;
    Panel1: TPanel;
    OpenDialog: TOpenDialog;
    StatusBar: TStatusBar;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    ImageWave: TImage;
    ImageFFT: TImage;
    Label1: TLabel;
    StaticText1: TStaticText;
    LbLength: TLabel;
    Label3: TLabel;
    LbLengthFormat: TLabel;
    Label5: TLabel;
    LbFormatTag: TLabel;
    Label6: TLabel;
    LbChannels: TLabel;
    Label7: TLabel;
    LbSamplesPerSec: TLabel;
    Label8: TLabel;
    LbAvgBytesPerSec: TLabel;
    Label9: TLabel;
    LbBlockAlign: TLabel;
    Label4: TLabel;
    LbDataLength: TLabel;
    SOMGer: TSOM;
    Panel6: TPanel;
    MemoTest: TMemo;
    Panel7: TPanel;
    LabelDigit: TLabel;
    MLP: TMLP;
    Panel8: TPanel;
    Label2: TLabel;
    EdPathFile: TEdit;
    Label10: TLabel;
    LbFiles: TListBox;
    BtnCapture: TBitBtn;
    BtnGenerate: TBitBtn;
    Panel9: TPanel;
    BtnTrain: TBitBtn;
    Panel10: TPanel;
    St1: TStaticText;
    St2: TStaticText;
    St3: TStaticText;
    St5: TStaticText;
    St4: TStaticText;
    St6: TStaticText;
    St8: TStaticText;
    St7: TStaticText;
    St9: TStaticText;
    St0: TStaticText;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BtnGenerateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnCaptureClick(Sender: TObject);
    procedure BtnTrainClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    { Faixa de valores possveis }
    Minimo, Maximo: array[0..30] of extended;

    { Vetor para teste da rede SOM }
    X: array of extended;

    { Retngulo temporrio }
    ARect: TRect;

    { Tamanho da janela de visualizao da amostra }
    SamplerView: integer;

    { Volume }
    Volume: integer;

    { Parmetros de visualizao }
    { Altura, largura, diferena, quantidade de bin }
    BinHeight, BinWidth, DeltaBin, BinCount: integer;

    { Limite de corte de rudo de fundo }
    NoiseCut: integer;

    { Limite inferior de bins para corte }
    LowCut: integer;

    { Vetor temporrio para dados de FFT }
    DataFFT: array[1..DATASIZE*2] of double;

    { Vetor para armazenar espectro de freqncias }
    Espectro : array[1..DATASIZE] of double;

    { Matriz para treinamento da rede MLP }
    MLPData : array[0..999,0..30] of double; // mximo de 200 amostras

    { Contador para amostras de MLP }
    SampleCount: integer;
    
    { Manipulador para arquivo de texto }
    F: TextFile;
    FFileName: string;

    { Mostra a estrutura do arquivo RIFF }
    procedure ShowStructure;

    { Mostra o sinal carregado do arquivo WAV }
    procedure ShowSignal;

    { Mostra a FFT esttica do sinal }
    procedure ShowFFT;

    { Mostra a FFT com janela deslizante }
    procedure ShowFFTWin;

  end;

var
  FTreinSOMMLP: TFTreinSOMMLP;

implementation

{$R *.DFM}

procedure TFTreinSOMMLP.FormActivate(Sender: TObject);
begin
   { Limpa campos }
   LbLength.Caption := '';
   LbLengthFormat.Caption := '';
   LbFormatTag.Caption := '';
   LbChannels.Caption := '';
   LbSamplesPerSec.Caption := '';
   LbAvgBytesPerSec.Caption := '';
   LbBlockAlign.Caption := '';
   LbDataLength.Caption := '';

   { Parmetros de vizualizao }
   BinWidth := 8;
   BinHeight := 12;
   DeltaBin := 3;
   BinCount := 42;
   NoiseCut := 10;
   LowCut := 12;
end;

procedure TFTreinSOMMLP.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action := caFree;
   FTreinSOMMLP := nil;
end;

procedure TFTreinSOMMLP.FormResize(Sender: TObject);
begin
   { Divide a janela de visualizao em duas: Amostra e FFT }
   Panel5.Height := Panel3.Height div 2;
   Panel5.Repaint;
end;

procedure TFTreinSOMMLP.ShowStructure;
begin
   LbLength.Caption := Format('%d',[WaveHandle.Length]);
   LbLengthFormat.Caption := Format('%d',[WaveHandle.LengthFormat]);
   LbFormatTag.Caption := Format('%d',[WaveHandle.FormatTag]);
   LbChannels.Caption := Format('%d',[WaveHandle.Channels]);
   LbSamplesPerSec.Caption := Format('%d',[WaveHandle.SamplesPerSec]);
   LbAvgBytesPerSec.Caption := Format('%d',[WaveHandle.AvgBytesPerSec]);
   LbBlockAlign.Caption := Format('%d',[WaveHandle.BlockAlign]);
   LbDataLength.Caption := Format('%d',[WaveHandle.LengthData]);

   SamplerView := WaveHandle.LengthData div 16384;
   if SamplerView = 0 then SamplerView := 1;
end;

procedure TFTreinSOMMLP.ShowSignal;
var i, j, n : integer;
   k : longint;
   Volume : longint;
   ARect : TRect;
begin
   ARect := Rect(0, 0, ImageWave.Width, ImageWave.Height);
   ImageWave.Canvas.Brush.Color := clBlack;
   ImageWave.Canvas.FillRect(ARect);

   Volume := 65536 * 1; //SpinEdit1.Value;

   ImageWave.Canvas.Pen.Color := clLime;
   if WaveHandle.Channels = 1 then
   begin
      k := 0;
      for j := 0 to WaveHandle.NumBuffers-1 do
      begin
         i := 0;
         while i < 32768 do
         begin
            ImageWave.Canvas.MoveTo(Round(k * 2 * ImageWave.Width / WaveHandle.LengthData),
                                    (ImageWave.Height div 2) - WaveHandle.Buffer[j][i]*ImageWave.Height div Volume);
            Inc(k, SamplerView);
            Inc(i, SamplerView);
            ImageWave.Canvas.LineTo(Round(k * 2 * ImageWave.Width / WaveHandle.LengthData),
                                    (ImageWave.Height div 2) - WaveHandle.Buffer[j][i]*ImageWave.Height div Volume);
         end;
      end;

      // resto
      i := 0;
      n := WaveHandle.NumBuffers;
      while i < WaveHandle.BytesRemain do
      begin
         ImageWave.Canvas.MoveTo(Round(k * 2 * ImageWave.Width / WaveHandle.LengthData),
                                 (ImageWave.Height div 2) - WaveHandle.Buffer[n][i]*ImageWave.Height div Volume);
         Inc(k, SamplerView);
         Inc(i, SamplerView);
         ImageWave.Canvas.LineTo(Round(k * 2 * ImageWave.Width / WaveHandle.LengthData),
                                 (ImageWave.Height div 2) - WaveHandle.Buffer[n][i]*ImageWave.Height div Volume);
      end;
   end;
end;

procedure TFTreinSOMMLP.ShowFFT;
var i, j, k: integer;
   Fator: integer;
begin
   FFT.Size := DATASIZE;

   i := 1;
   while i <= DATASIZE do
   begin
      DataFFT[2*i-1] := (WaveHandle.Buffer[0][i-1] + 32768) / 32768;
      DataFFT[2*i] := 0;
      Inc(i);
   end;

   { Faz FFT }
   FFT.DoFFT(DataFFT);

   { Calcula espectro de frequncias }
   i := 1;
   while (i <= FFT.Size) do
   begin
      Espectro[i] := Sqrt(DataFFT[2*i-1]*DataFFT[2*i-1] + DataFFT[2*i]*DataFFT[2*i]);
      Inc(i);
   end;

   { Limpa TImage }
   ARect := Rect(0, 0, ImageFFT.Width, ImageFFT.Height);
   ImageFFT.Canvas.Brush.Color := clBlack;
   ImageFFT.Canvas.FillRect(ARect);

   { Preenche com espectro }
   ImageFFT.Canvas.Pen.Color := clWhite;
   i := LowCut;
   while (i < BinCount) do
   begin
      ImageFFT.Canvas.MoveTo((i-1)*BinWidth, ImageFFT.Height);
      ImageFFT.Canvas.LineTo((i-1)*BinWidth, ImageFFT.Height  - BinHeight* Trunc(Espectro[i] * ImageFFT.Height/DATASIZE));
      Inc(i);
   end;

   { Preenche com espectro }
   ImageFFT.Canvas.Pen.Color := clWhite;
   i := LowCut;
   ImageFFT.Canvas.MoveTo((i-1)*BinWidth, ImageFFT.Height);
   while (i < BinCount) do
   begin
      ImageFFT.Canvas.LineTo((i-1)*BinWidth, ImageFFT.Height  - BinHeight * Trunc(Espectro[i] * ImageFFT.Height/DATASIZE));
      ImageFFT.Canvas.MoveTo((i-1)*BinWidth, ImageFFT.Height  - BinHeight * Trunc(Espectro[i] * ImageFFT.Height/DATASIZE));
      Inc(i);
   end;

end;

procedure TFTreinSOMMLP.ShowFFTWin;
var I, J, K, N: integer;
   Total: integer;
//   F: TextFile;
//   FName, FN: string;
   SampleLine: String;
   SampleBin: integer;
   W, WT, S: longint;
   First: boolean;
   V: array[0..9] of integer;
   R, Q: integer;
begin
   StatusBar.Panels[0].Text := 'Gerando amostras de FFT...';
   LabelDigit.Caption := '';

   FFT.Size := DATASIZE;
   Total := WaveHandle.BytesRemain + WaveHandle.NumBuffers * 32768;

   k := 0;
   WT := 100;
   MemoTest.Lines.Clear;

   { Zera o vetor para o prximo }
   for J := 0 to 9 do
   begin
      V[J] := 0;
   end;

   { Para MLP, pega o prximo dgito do nome }
   R := 1;
   Q := StrToInt(Copy(FFileName,R,1));

   { Contador para a rede MLP }
   while k < Total do
   begin
      i := 1;
      while i <= FFT.Size do
      begin
         DataFFT[2*i-1] := (WaveHandle.Buffer[0][i+k-1] + 32768) / 32768;
         DataFFT[2*i] := 0;
         Inc(i);
      end;

      { Faz FFT }
      FFT.DoFFT(DataFFT);

      { Calcula espectro de frequncias }
      i := 1;
      while (i <= FFT.Size) do
      begin
         Espectro[i] := Sqrt(DataFFT[2*i-1]*DataFFT[2*i-1] + DataFFT[2*i]*DataFFT[2*i]);
         Inc(i);
      end;

      { Limpa TImage }
      ARect := Rect(0, 0, ImageFFT.Width, ImageFFT.Height);
      ImageFFT.Canvas.Brush.Color := clBlack;
      ImageFFT.Canvas.FillRect(ARect);

      { Preenche com espectro }
      SampleLine := '';
      i := LowCut;
      J := 0;
      while (i < BinCount) do
      begin
         if Espectro[i] > 10 then
         begin
            ImageFFT.Canvas.Pen.Color := clRed;
            ImageFFT.Canvas.Brush.Color := clRed;
         end
         else
         if Espectro[i] < 4 then
         begin
            ImageFFT.Canvas.Pen.Color := clBlue;
            ImageFFT.Canvas.Brush.Color := clBlue;
         end
         else
         begin
            ImageFFT.Canvas.Pen.Color := clYellow;
            ImageFFT.Canvas.Brush.Color := clYellow;
         end;

         ImageFFT.Canvas.Rectangle((i-1)*BinWidth-DeltaBin,
                                 ImageFFT.Height,
                                 (i-1)*BinWidth+DeltaBin,
                                 ImageFFT.Height  - BinHeight*Trunc(Espectro[i]*ImageFFT.Height/DATASIZE));

         SampleBin := Trunc(Espectro[i]);
         if SampleBin <= NoiseCut then SampleBin := 0;
         SampleLine := SampleLine + Format('%5d',[SampleBin]);
         X[j] := SampleBin;

         { Guarda o bin para treinar a rede MLP }
         MLPData[SampleCount,j] := SampleBin;

         Inc(i);
         Inc(j);
      end;

      { Faz o somatrio dos bins }
      S := 0;
      for J := 0 to SOMGer.Dimension-1 do
      begin
         S := S + Trunc(X[J]);
      end;

      { Verifica o peso a que pertence a amostra }
      W := SOMGer.SeekWeight(X);

      if (S = 0) and First then
      begin
         {  outro dgito }
         { Escolhe o que ocorreu mais vezes }
         N := 0;
         for J := 1 to 9 do
         begin
            if V[J] > V[N] then
               N := J;
         end;

         { Mostra o dgito escolhido }
         LabelDigit.Caption := LabelDigit.Caption + IntToStr(N);

         { Zera o vetor para o prximo }
         for J := 0 to 9 do
         begin
            V[J] := 0;
         end;
         First := False;

         { Para MLP, pega o prximo dgito do nome }
         Inc(R);
         if R <= Length(FFileName) then Q := StrToInt(Copy(FFileName,R,1));
      end
      else
      begin
         { Aumenta uma ocorrncia }
         MemoTest.Lines.Add(StringOfChar(' ',W*3) + IntToStr(W));
         Inc(V[W]);
         First := True;
      end;

      if (S = 0) then
      begin
         { Marcador para pausa entre dgitos } 
         SampleLine := SampleLine + '   -1';
         MLPData[SampleCount,30] := -1;
      end
      else
      begin
         SampleLine := SampleLine + Format('%5d',[Q]);
         MLPData[SampleCount,30] := Q;
      end;

      ImageFFT.Canvas.Pen.Color := clWhite;
      i := LowCut;
      while (i < BinCount) do
      begin
         ImageFFT.Canvas.MoveTo((i-1)*BinWidth, ImageFFT.Height);
         ImageFFT.Canvas.LineTo((i-1)*BinWidth, ImageFFT.Height-10);
         Inc(i);
      end;

      WriteLn(F, SampleLine);

      Application.ProcessMessages;
      Sleep(33);
      Inc(k,FFT.Size);
      Inc(SampleCount);
   end;

   StatusBar.Panels[0].Text := 'Arquivo de amostra de FFT gerado';
end;


procedure TFTreinSOMMLP.BtnGenerateClick(Sender: TObject);
var FileCount: integer;
    FName: string;
    TempName: string;
begin
   { Abre arquivo e analisa no WaveHandle }
   BtnGenerate.Enabled := False;

   FName := 'SMP.TXT';
   AssignFile(F, FName);
   Rewrite(F);
   SampleCount := 0;

   for FileCount := 0 to LbFiles.Count-1 do
   begin
      LbFiles.Selected[FileCount] := True;
      LbFiles.Repaint;
      TempName := ExtractFileName(LbFiles.Items.Strings[FileCount]);
      FFileName := Copy(TempName,1,Pos('.', TempName)-1);

      WaveHandle.Clear;
      WaveHandle.WAVFile := LbFiles.Items.Strings[FileCount];
      WaveHandle.Load;

      ARect := Rect(0, 0, ImageWave.Width, ImageWave.Height);
      ImageWave.Canvas.Brush.Color := clBlack;
      ImageWave.Canvas.FillRect(ARect);

      ShowStructure;
      ShowSignal;
      ShowFFT;

      { Gera a amostra para o dgito considerado }
      ShowFFTWin;
      StatusBar.Panels[1].Text := IntToStr(SampleCount) + ' amostra(s) para MLP';
//      Application.ProcessMessages;
   end;

   CloseFile(F);

   BtnTrain.Enabled := True;
end;

procedure TFTreinSOMMLP.FormCreate(Sender: TObject);
var I: integer;
begin
   MemoTest.Lines.Clear;

   { Ajusta parmetros iniciais das redes SOM }
   SOMGer.Dimension := 30;
   SOMGer.Points := 110;
   SOMGer.Weights := 10;

   for I := 0 to SOMGer.Dimension-1 do
   begin
      Minimo[i] := 0;
      Maximo[i] := 2000;
   end;

   SOMGer.Bounds(Minimo, Maximo);
   SOMGer.Build;
   { Carrega arquivo de treinamento }
   SOMGer.Load;
   { Aloca espao para vetor de teste }
   SetLength(X, SOMGer.Dimension);

   LabelDigit.Caption := '';

   { Rede MLP }
   { Coloca camadas }
   MLP.Struct.Clear;
   MLP.Struct.Add('30');
   MLP.Struct.Add('11');

   { Constri a rede }
   MLP.Build;

   { Seta faixa de valores permitida }
   { Camada de entrada }
   for I := 1 to 30 do
   begin
      MLP.SetInputMin(I,0);
      MLP.SetInputMax(I,100);
   end;

   { Camada de sada }
   for I := 1 to 11 do
   begin
      MLP.SetOutputMin(I,0);
      MLP.SetOutputMax(I,1);
   end;

end;

procedure TFTreinSOMMLP.BtnCaptureClick(Sender: TObject);
begin
   OpenDialog.InitialDir := EdPathFile.Text;
   if OpenDialog.Execute then
   begin
      LbFiles.Items := OpenDialog.Files;
   end;
   BtnGenerate.Enabled := True;
end;

procedure TFTreinSOMMLP.BtnTrainClick(Sender: TObject);
var I, J, K: integer;
begin
   { pocas }
   for K := 0 to 1000 do
   begin
      { Quantidade de amostras }
      for J := 0 to SampleCount-1 do
      begin
         { Alimenta a camada de entrada }
         for I := 0 to 29 do
         begin
            MLP.SetInput(I,MLPData[J,I]);
         end;

         { Alimenta a camada de sada }
         for I := 1 to 11 do
         begin
            MLP.SetOutput(I,0);
         end;
         if MLPData[J,30] <> -1 then
            MLP.SetOutput(Trunc(MLPData[J,30]),1)
         else
            MLP.SetOutput(11,1);

         { Treina a rede }
         MLP.Training;

         { Flag visual }
         St0.Color := clBlue;
         St1.Color := clBlue;
         St2.Color := clBlue;
         St3.Color := clBlue;
         St4.Color := clBlue;
         St5.Color := clBlue;
         St6.Color := clBlue;
         St7.Color := clBlue;
         St8.Color := clBlue;
         St9.Color := clBlue;

         if MLPData[J,30] = 0 then St0.Color := clRed;
         if MLPData[J,30] = 1 then St1.Color := clRed;
         if MLPData[J,30] = 2 then St2.Color := clRed;
         if MLPData[J,30] = 3 then St3.Color := clRed;
         if MLPData[J,30] = 4 then St4.Color := clRed;
         if MLPData[J,30] = 5 then St5.Color := clRed;
         if MLPData[J,30] = 6 then St6.Color := clRed;
         if MLPData[J,30] = 7 then St7.Color := clRed;
         if MLPData[J,30] = 8 then St8.Color := clRed;
         if MLPData[J,30] = 9 then St9.Color := clRed;

         { Mostra erro global }
         StatusBar.Panels[2].Text := 'pocas: ' + Format('%4d', [K]) + ' Erro: ' + Format('%3.6f', [MLP.Cost]);
         StatusBar.Repaint;
         Application.ProcessMessages;
      end;
   end;

   { Salva }
   MLP.Save;
end;

end.

