unit UnitXor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, Buttons, ExtCtrls, MLP, ComCtrls, Grids;

type
  TFXOR = class(TForm)
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    BtnXORC: TBitBtn;
    SgXORC: TStringGrid;
    GroupBox2: TGroupBox;
    BtnXORS: TBitBtn;
    SgXORS: TStringGrid;
    MLPS: TMLP;
    MLPC: TMLP;
    procedure FormCreate(Sender: TObject);
    procedure BtnXORCClick(Sender: TObject);
    procedure BtnXORSClick(Sender: TObject);
  private
    { Private declarations } 
  public
    { Public declarations }
  end;

const A: array[1..8] of double = (0, 0, 1, 1, 0.0, 0.0, 0.8, 0.8);
      B: array[1..8] of double = (0, 1, 1, 0, 0.0, 0.8, 0.8, 0.0);
      S: array[1..8] of double = (0, 1, 0, 1, 0.0, 1.0, 0.0, 1.0);

var
  FXOR: TFXOR;

implementation

{$R *.dfm}

procedure TFXOR.FormCreate(Sender: TObject);
begin
   { Preenchimento dos grids }
   SgXORS.Cells[0,0] := 'E1';
   SgXORS.Cells[1,0] := 'E2';
   SgXORS.Cells[2,0] := 'S';
   SgXORS.Cells[3,0] := 'ST';

   SgXORS.Cells[0,1] := '0';
   SgXORS.Cells[0,2] := '0';
   SgXORS.Cells[0,3] := '1';
   SgXORS.Cells[0,4] := '1';
   SgXORS.Cells[1,1] := '0';
   SgXORS.Cells[1,2] := '1';
   SgXORS.Cells[1,3] := '0';
   SgXORS.Cells[1,4] := '1';

   SgXORC.Cells[0,0] := 'E1';
   SgXORC.Cells[1,0] := 'E2';
   SgXORC.Cells[2,0] := 'S';
   SgXORC.Cells[3,0] := 'ST';

   SgXORC.Cells[0,1] := '0';
   SgXORC.Cells[0,2] := '0';
   SgXORC.Cells[0,3] := '1';
   SgXORC.Cells[0,4] := '1';
   SgXORC.Cells[1,1] := '0';
   SgXORC.Cells[1,2] := '1';
   SgXORC.Cells[1,3] := '0';
   SgXORC.Cells[1,4] := '1';

   { Rede MLP sem camada oculta }
   MLPS.Struct.Clear;
   MLPS.Struct.Add('2');
   MLPS.Struct.Add('1');
   MLPS.Build;
   MLPS.SetInputMin(1, 0);
   MLPS.SetInputMax(1, 1);
   MLPS.SetInputMin(2, 0);
   MLPS.SetInputMax(2, 1);
   MLPS.SetOutputMin(1, 0);
   MLPS.SetOutputMax(1, 1);
   MLPS.Learning:= 0.9;
   MLPS.Momentum:= 0.4;
   MLPS.Flatness := 2;

   { Rede MLP com camada oculta }
   MLPC.Struct.Clear;
   MLPC.Struct.Add('2');
   MLPC.Struct.Add('2');
   MLPC.Struct.Add('1');
   MLPC.Build;
   MLPC.SetInputMin(1, 0);
   MLPC.SetInputMax(1, 1);
   MLPC.SetInputMin(2, 0);
   MLPC.SetInputMax(2, 1);
   MLPC.SetOutputMin(1, 0);
   MLPC.SetOutputMax(1, 1);
   MLPC.SetBias(2, 1, -5.5);  // valores de bias para os neurnios
   MLPC.SetBias(2, 2, -1.5);
   MLPC.SetBias(3, 1, 0.475);
   MLPC.Learning:= 0.9;
   MLPC.Momentum:= 0.4;
   MLPC.Flatness := 2;
end;

procedure TFXOR.BtnXORCClick(Sender: TObject);
var i, j, k: integer;
begin
   { Treinamento da rede MLP com camada oculta }
   for k := 0 to 1000 do
   begin
      j := 1;
      while j <= 8 do
      begin
         MLPC.SetInput(1, A[j]);
         MLPC.SetInput(2, B[j]);
         MLPC.SetOutput(1, S[j]);
         MLPC.Training;
         StatusBar1.Panels[0].Text := 'pocas: ' + IntToStr(k);
         StatusBar1.Panels[1].Text := Format('Erro Atual: %2.12f',[MLPC.Cost]);
         StatusBar1.Repaint;
         Inc(j);
      end;
   end;
   MLPC.Save;

   { Teste da rede MLP com camada oculta }
   MLPC.Load;
   for i:= 0 to 1 do
      for j:= 0 to 1 do
      begin
         MLPC.SetInput(1, i);
         MLPC.SetInput(2, j);
         MLPC.Test;
         SgXORC.Cells[2,i*2+j+1] := Format('%2.3f',[MLPC.GetOutput(1)]);
         SgXORC.Cells[3,i*2+j+1] := Format('%d',[Trunc(MLPC.GetOutput(1))]);
      end;

end;

procedure TFXOR.BtnXORSClick(Sender: TObject);
var i, j, k: integer;
begin
   { Treinamento da rede MLP sem camada oculta }
   for k := 0 to 1000 do
   begin
      j := 1;
      while j <= 8 do
      begin
         MLPS.SetInput(1, A[j]);
         MLPS.SetInput(2, B[j]);
         MLPS.SetOutput(1, S[j]);
         MLPS.Training;
         StatusBar1.Panels[0].Text := 'pocas: ' + IntToStr(k);
         StatusBar1.Panels[1].Text := Format('Erro Atual: %2.12f',[MLPS.Cost]);
         StatusBar1.Repaint;
         Inc(j);
      end;
   end;
   MLPS.Save;

   { Teste da rede MLP sem camada oculta }
   MLPS.Load;
   for i:= 0 to 1 do
      for j:= 0 to 1 do
      begin
         MLPS.SetInput(1, i);
         MLPS.SetInput(2, j);
         MLPS.Test;
         SgXORS.Cells[2,i*2+j+1] := Format('%2.3f',[MLPS.GetOutput(1)]);
         SgXORS.Cells[3,i*2+j+1] := Format('%d',[Trunc(MLPS.GetOutput(1))]);
      end;

end;

end.
