unit USomCount;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Math, Som, ComCtrls;

type
  TFSomCount = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    btnSOM: TBitBtn;
    Panel3: TPanel;
    GroupBox1: TGroupBox;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Image1: TImage;
    Label8: TLabel;
    Label9: TLabel;
    btnInicial: TBitBtn;
    btnVoronoi: TBitBtn;
    Label11: TLabel;
    TrackBar8: TTrackBar;
    Edit8: TEdit;
    SOM: TSOM;
    Memo: TMemo;
    Label10: TLabel;
    LbCount: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure btnSOMClick(Sender: TObject);
    procedure SOMIteration(Sender: TObject; Epochs: Integer);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure TrackBar7Change(Sender: TObject);
    procedure btnInicialClick(Sender: TObject);
    procedure btnVoronoiClick(Sender: TObject);
    procedure TrackBar8Change(Sender: TObject);
    procedure SOMUpdateSOMGauss(Sender: TObject; Epochs: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    Bitmap1: TBitmap;
    x : TSOMArrayInput;
    Minimo, Maximo: array[0..1] of extended;
    tx, ty: array[0..511] of integer;
    m: array[0..511] of integer;
    Grid: array[0..255,0..255] of integer;
  end;

var
  FSomCount: TFSomCount;

implementation

{$R *.DFM}

procedure TFSomCount.FormActivate(Sender: TObject);
var i: integer;
begin
   { Define tamanho do bitmap }
   Bitmap1 := TBitmap.Create;
   Bitmap1.Height := 255;
   Bitmap1.Width := 255;

   { Cria a rede SOM pela primeira vez }
   SOM.Dimension := 2;
   SOM.Weights := TrackBar1.Position;
   SOM.Points := TrackBar2.Position;
   SOM.Iterations := TrackBar3.Position;
   SOM.Build;

   { Acerta tamanho do vetor de entrada }
   SetLength(x, TrackBar2.Position, SOM.Dimension);

   { Acerta os limites de valores para os pesos }
   for i := 0 to SOM.Dimension-1 do
   begin
      Minimo[i] := 0;
      Maximo[i] := 1;
   end;
   SOM.Bounds(Minimo, Maximo);

   { Apresenta os valores nos campos Edit }
   TrackBar1Change(Sender);
   TrackBar2Change(Sender);
   TrackBar3Change(Sender);
   TrackBar4Change(Sender);
   TrackBar5Change(Sender);
   TrackBar6Change(Sender);
   TrackBar7Change(Sender);
   TrackBar8Change(Sender);
end;

procedure TFSomCount.btnInicialClick(Sender: TObject);
var i, j, CenterX, CenterY, Ray, xp, yp : integer;
   ARect : TRect;
begin
   { Inicializa e constri a rede SOM }
   SOM.Clear;
   SOM.Weights := TrackBar1.Position;
   SOM.Points := TrackBar2.Position;
   SOM.Iterations := TrackBar3.Position;
   SOM.Build;

   { Apaga o bitmap }
   ARect := Rect(0, 0, 255, 255);
   Bitmap1.Canvas.Brush.Color := clWhite;
   Bitmap1.Canvas.FillRect(ARect);

   { Desenha os clusters }
   for i := 0 to TrackBar8.Position-1 do
   begin
      Bitmap1.Canvas.Pen.Color := clAqua;
      Bitmap1.Canvas.Brush.Color := clAqua;
      CenterX := 10 + Random(234);
      CenterY := 10 + Random(234);
      Ray := 5 + Random(5);
      Bitmap1.Canvas.Ellipse(CenterX-Ray, CenterY-Ray, Round(CenterX+Ray), Round(CenterY+Ray));
      Bitmap1.Canvas.FloodFill(CenterX, CenterY, clAqua, fsSurface);
   end;

   { Verifica quantos pontos em clusters existem }
   j := 0;
   for xp := 0 to 254 do
      for yp := 0 to 254 do
         if Bitmap1.Canvas.Pixels[xp,yp] = clAqua then
            Inc(j);

   { Ajusta os pontos e preenche o vetor de entrada para rede SOM }
   TrackBar2.Position := j;
   TrackBar2Change(Sender);
   {}
   SOM.Points := j;
   SetLength(x, TrackBar2.Position, SOM.Dimension);
   Application.ProcessMessages;
   j := 0;
   for xp := 0 to 254 do
   begin
      for yp := 0 to 254 do
      begin
         if Bitmap1.Canvas.Pixels[xp,yp] = clAqua then
         begin
            x[j,0] := xp;
            x[j,1] := yp;
            Inc(j);
         end;
      end;
   end;

   { Assinala valores aleatrios para os pesos }
   Bitmap1.Canvas.Pen.Color := clNavy;
   Bitmap1.Canvas.Brush.Color := clWhite;
   for i := 0 to SOM.Weights-1 do
   begin
      for j := 0 to SOM.Dimension-1 do
         SOM.SetValue(i, j, Random(251));
      Bitmap1.Canvas.Rectangle(Round(SOM.GetValue(i,0)), Round(SOM.GetValue(i,1)), Round(SOM.GetValue(i,0)+5), Round(SOM.GetValue(i,1)+5));
   end;

   { Mostra bitmap }
   Image1.Picture.Assign(Bitmap1);
   btnSOM.Enabled := True;
end;

procedure TFSomCount.btnSOMClick(Sender: TObject);
var i, j, k: integer;
begin
   LbCount.Caption := '';
   Memo.Lines.Clear;

   { Zera vetor para controle de movimento de pesos }
   for i := 0 to SOM.Weights-1 do
      m[i] := 0;

   with SOM do DoSOMGauss(x);
   btnInicial.Enabled := True;
   btnSOM.Enabled := False;

   { Zera posies no vetor do grid }
   for j := 0 to 255 do
      for k := 0 to 255 do
         Grid[j,k] := 0;

   for i := 0 to SOM.Weights-1 do
   begin
      { Apenas os que apresentaram movimento acima de um limiar }
      if m[i] > 3 then
      begin
         Grid[tx[i],ty[i]] := Grid[tx[i],ty[i]] + 1;
      end;
   end;

   { Mostra os pontos dos clusters encontrados }
   Memo.Lines.Clear;
   for j := 0 to 255 do
   begin
      for k := 0 to 255 do
      begin
         if Grid[j,k] > 0 then
            Memo.Lines.Add('(' + IntToStr(j)+','+IntToStr(k)+')');
      end;
   end;
   LbCount.Caption := IntToStr(Memo.Lines.Count);

end;

procedure TFSomCount.SOMIteration(Sender: TObject; Epochs: Integer);
var i, j : integer;
   ARect : TRect;
begin
   { Apaga bitmap }
   ARect := Rect(0, 0, 255, 255);
   Bitmap1.Canvas.Brush.Color := clWhite;
   Bitmap1.Canvas.FillRect(ARect);

   { Desenha os pontos }
   Bitmap1.Canvas.Pen.Color := clAqua;
   for j := 0 to SOM.Points-1 do
   begin
      Bitmap1.Canvas.Rectangle(Round(x[j,0]), Round(x[j,1]), Round(x[j,0]+2), Round(x[j,1]+2));
   end;

   { Desenha os pesos }
   Bitmap1.Canvas.Pen.Color := clNavy;
   with SOM do
   begin
      for i := 0 to SOM.Weights-1 do
         Bitmap1.Canvas.Rectangle(Round(GetValue(i,0)), Round(GetValue(i,1)), Round(GetValue(i,0)+5), Round(GetValue(i,1)+5));
   end;
   Label8.Caption := IntToStr(Epochs);
   Image1.Picture.Assign(Bitmap1);

   { Acima de um limiar de iteraes, comea a processar a contagem }
   if Epochs > 500 then
   begin
      for i := 0 to SOM.Weights-1 do
      begin
         { Se a posio do peso mudou, arazena a posio }
         if (tx[i] <> Round(SOM.GetValue(i,0))) or (ty[i] <> Round(SOM.GetValue(i,1))) then
         begin
            tx[i] := Round(SOM.GetValue(i,0));
            ty[i] := Round(SOM.GetValue(i,1));
            { Conta a quantidade de atualizaes da posio do peso i}
            m[i] := m[i] + 1;
         end;
      end;
   end;

   Application.ProcessMessages;
end;

procedure TFSomCount.btnVoronoiClick(Sender: TObject);
var i, j, k, d, dmin, kmin, kant : integer;
begin
   { Desenha as clulas de Voronoi }
   kmin := 0;
   kant := 0;
   for j := 0 to 254 do
   begin
      for i := 0 to 254 do
      begin
         dmin := MaxInt;
         for k := 0 to SOM.Weights-1 do
         begin
            d := Round(Sqrt((i - SOM.GetValue(k, 0))*(i - SOM.GetValue(k, 0)) + (j - SOM.GetValue(k, 1))*(j - SOM.GetValue(k, 1))));
            if d < dmin then
            begin
               dmin := d;
               kmin := k;
            end;
         end;
         if kmin <> kant then
         begin
            Bitmap1.Canvas.Pixels[i,j] := clNavy;
            kant := kmin;
         end;
      end;
   end;
   Image1.Picture.Assign(Bitmap1);
end;

procedure TFSomCount.SOMUpdateSOMGauss(Sender: TObject; Epochs: Integer);
begin
   { Atualiza parmetros da rede SOM }
   with SOM do
   begin
      Sigma := TrackBar4.Position * exp(-Epochs/TrackBar5.Position);
      RateSOM := (TrackBar6.Position/10) * exp(-Epochs/TrackBar7.Position);
   end;
end;

procedure TFSomCount.TrackBar1Change(Sender: TObject);
begin
   { Nmero de pesos }
   Edit1.Text := IntToStr(TrackBar1.Position);
end;

procedure TFSomCount.TrackBar2Change(Sender: TObject);
begin
   { Quantidade de pontos }
   Edit2.Text := IntToStr(TrackBar2.Position);
end;

procedure TFSomCount.TrackBar3Change(Sender: TObject);
begin
   { Nmero de iteraes }
   Edit3.Text := IntToStr(TrackBar3.Position);
end;

procedure TFSomCount.TrackBar4Change(Sender: TObject);
begin
   { Sigma Inicial }
   Edit4.Text := IntToStr(TrackBar4.Position);
end;

procedure TFSomCount.TrackBar5Change(Sender: TObject);
begin
   { Taxa de decaimento para sigma }
   Edit5.Text := IntToStr(TrackBar5.Position);
end;

procedure TFSomCount.TrackBar6Change(Sender: TObject);
begin
   { Taxa de Atualizao inicial }
   Edit6.Text := FloatToStr(TrackBar6.Position/10);
end;

procedure TFSomCount.TrackBar7Change(Sender: TObject);
begin
   { Decaimento para taxa de atualizao }
   Edit7.Text := IntToStr(TrackBar7.Position);
end;

procedure TFSomCount.TrackBar8Change(Sender: TObject);
begin
   { Nmero de clusters }
   Edit8.Text := FloatToStr(TrackBar8.Position);
end;

end.
